#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define MAX_ENTRIES 100
#define MAX_STRING_LENGTH 100

struct liste {
	char name[MAX_STRING_LENGTH];
	int points;
};

void usage(const char *prog) {	
	fprintf(stderr, "Usage: %s <Punktedatei Studentendatei>\n", prog);
}

void bubble(struct liste *studis, const unsigned size) {
	unsigned int i, j;
	struct liste temp;
	char * nachname1;		
	char * nachname2;		

	for (i = 0; i + 1 < size; i++) {
		for (j = (i + 1); j < size; j++) {

			/* Nach Vorname sortieren */
			if (strcasecmp(studis[i].name, studis[j].name) > 0) {
				temp = studis[j];
				studis[j] = studis[i];
				studis[i] = temp;
			}

			/* Nach Nachname sortieren */
			nachname1 = strrchr(studis[i].name, ' ');
			nachname2 = strrchr(studis[j].name, ' ');

			if (strcasecmp(nachname1, nachname2) > 0) {
				temp = studis[j];
				studis[j] = studis[i];
				studis[i] = temp;
			}
		}
	}
}

int main(const int argc, const char **argv) {

	const char *progname;
	char datei1 [20];
	char datei2 [20];

	FILE *fp = NULL;
	FILE *fs = NULL;

	char buf [MAX_STRING_LENGTH];
	struct liste punkte[MAX_ENTRIES];
	struct liste studis[MAX_ENTRIES];

	int sizeliste1, sizeliste2;
	int i, j, inliste = 0;
	const char *token;

	progname = argv[0];
	if (argc != 3) {
		usage(progname);
		return 1;
	}

	sscanf(argv[1], "%s", datei1);
	sscanf(argv[2], "%s", datei2);

	if (!(fp = fopen(argv[1], "r"))) {
		usage(progname);
		fclose(fp);
		return 1;
	}

	sizeliste1 = 0;
	while (fgets(buf, MAX_STRING_LENGTH, fp) > 0) {
		token = strtok(buf, ":");
		strcpy(punkte[sizeliste1].name, token);
		token = strtok(NULL, ":");
		sscanf(token, "%d", &punkte[sizeliste1].points);
		sizeliste1++;
	}
	fclose(fp);

	if (!(fs = fopen(argv[2], "r"))) {
		usage(progname);
		fclose(fs);
		return 1;
	}

	sizeliste2 = 0;
	while (fgets(buf, MAX_STRING_LENGTH, fs) > 0) {
		token = strtok(buf, ":");
		strcpy(studis[sizeliste2].name, token);
		token = strtok(NULL, ":");
		sscanf(token, "%d", &studis[sizeliste2].points);
		sizeliste2++;
	}
	fclose(fs);

	for (i = 0; i < sizeliste1; i++) {
		inliste = 0;
		for (j = 0; j < sizeliste2; j++) {
			if (strcasecmp(punkte[i].name, studis[j].name) == 0) {
				studis[j].points += punkte[i].points;
				inliste = 1;
				break;
			}
		}
		if (inliste == 0) {
			fprintf(stderr, "Fehler: %s ist nicht in Teilnehmerliste\n", punkte[i].name);
		}
	}

	bubble(studis, sizeliste2);

	for (i = 0; i < sizeliste2; i++) {
		printf("%s:", studis[i].name);
		printf("%d\n", studis[i].points);
	}

	return 0;

}
